function ent = dctent(Yr,step,N)

% function ent = dctent(Yr,step,N)
% Calculate the entropy of each of the N x N bands of DCT coefs.
% Assumes that Yr has been regrouped into separate sub-images.
% step defines the entropy step-size.

ent = zeros(N,N);
[m,n] = size(Yr);
tr = 1:m/N;
tc = 1:n/N;
for i=1:N,
  for k=1:N,
    [n0,x0] = hist2d(round(Yr(tr+(i-1)*m/N,tc+(k-1)*n/N)/step));
    ent(i,k) = sum(entrop(n0));
    fprintf(1,'.');
  end
  fprintf(1,'\n');
end