echo off
% DEMO3.M
% I8 Coding Course - Lecture 1, Haar Transform Demonstrations:

clear all
% clfigs

global printon
% printon = input('Write print files (0=no, 1=norm, 2=hi Qstep, 3=RLC, +4 for .GIF files):');
printon = 3;
run = input('Calculate entropies based on run-lengths (1=yes, 0=no):');
qstep = input('Quantiser step size (15?) = ');
qstr = ['Qstep=' int2str(qstep)];

load lenna
X = X - 120; % Remove DC bias.
si = size(X);

disp(['Lenna image min, max, energy and entropy for ' qstr])
xmin = min(min(X))
xmax = max(max(X))
figure(2);
draw(X);
set(gcf,'numbertitle','off','name',['Lenna - Original'])
drawnow

[n0,x0] = hist2d(round(X/qstep));
eng0 = sum(sum(X.^2))

setfig(3);
set(gcf,'numbertitle','off','name',['Histogram of pels'])
subplot(1,1,1);
e0 = sum(entrop(n0,x0))
[bits, huffval, huffent] = genhuff2(n0); % huffent = huffman code entropy.
ehuff0 = sum(huffent)
title(['Lenna Image Histogram and Entropies for ' qstr],'FontSize',16)
xlabel(sprintf('Image energy = %.2fe6, entropy = %.3f bits.',eng0/1e6,e0),'FontSize',16);
drawnow
if printon==1,
  print -depsc \1ngk\tex\i8coding\i8de3h1.eps
end

figure(2);
if printon==5,
  drawfile(X,'\1ngk\tex\i8coding\i8de3p1.gif');
elseif printon==1,
  print -deps \1ngk\tex\i8coding\i8de3p1.eps
else
  pause
end

% Use a simple Haar transform to illustrate energy compression.
% Show histograms of the 4 sub-bands, perhaps using bin sizes of
% 4 steps and with energy normalised transforms.

X = haar2d(X);

figure(4)
draw(max(min(X,200),-200))
set(gcf,'numbertitle','off','name',['Level 1 Haar Transform'])
drawnow
if printon==0, pause, end

setfig(5);
set(gcf,'numbertitle','off','name',['Histograms - Level 1'])
[e1, ehuff1] = ent4plot(X,qstep,...
 ['Haar Transform, Level 1 energies, and entropies for ' qstr],...
 [-15 15*(1+run) 0 1],run);
if printon==1,
  print -depsc \1ngk\tex\i8coding\i8de3h2.eps
end
if printon==3,
  print -depsc \1ngk\tex\i8coding\i8de3h11.eps
end

figure(4)
if printon==5,
  drawfile(max(min(X,200),-200),'\1ngk\tex\i8coding\i8de3p2.gif');
elseif printon==1,
  print -deps \1ngk\tex\i8coding\i8de3p2.eps
else
  pause
end

% return

% 
% Show overall compression assuming a step size = qstep.
% 
% Repeat for 2 to 4 levels of Haar transform.

sx = round(si/2);
X(1:sx(1),1:sx(2)) = haar2d(X(1:sx(1),1:sx(2)));

figure(6);
set(gcf,'numbertitle','off','name',['Histograms - Level 2'])
[e2, ehuff2] = ent4plot(X(1:sx(1),1:sx(2)),qstep, ...
 ['Haar Transform, Level 2 energies, and entropies for ' qstr], ...
 [-30 30*(1+run) 0 0.8], run);
if printon==1,
  print -depsc \1ngk\tex\i8coding\i8de3h3.eps
end

figure(7);
draw(max(min(X(1:sx(1),1:sx(2)),400),-400));
set(gcf,'numbertitle','off','name',['Level 2 Haar Transform'])
drawnow
if printon==5,
  drawfile(max(min(X(1:sx(1),1:sx(2)),400),-400),'\1ngk\tex\i8coding\i8de3p3.gif');
elseif printon==1,
  print -deps \1ngk\tex\i8coding\i8de3p3.eps
else
  pause
end

sx = round(sx/2);
X(1:sx(1),1:sx(2)) = haar2d(X(1:sx(1),1:sx(2)));

figure(8);
set(gcf,'numbertitle','off','name',['Histograms - Level 3'])
[e3, ehuff3] = ent4plot(X(1:sx(1),1:sx(2)),qstep, ...
 ['Haar Transform, Level 3 energies, and entropies for ' qstr], ...
 [-60 60 0 0.6], run);
if printon==1,
  print -depsc \1ngk\tex\i8coding\i8de3h4.eps
end

figure(9);
draw(max(min(X(1:sx(1),1:sx(2)),800),-800));
set(gcf,'numbertitle','off','name',['Level 3 Haar Transform'])
drawnow
if printon==5,
  drawfile(max(min(X(1:sx(1),1:sx(2)),800),-800),'\1ngk\tex\i8coding\i8de3p4.gif');
elseif printon==1,
  print -deps \1ngk\tex\i8coding\i8de3p4.eps
else
  pause
end

sx = round(sx/2);
X(1:sx(1),1:sx(2)) = haar2d(X(1:sx(1),1:sx(2)));

figure(10);
set(gcf,'numbertitle','off','name',['Histograms - Level 4'])
[e4, ehuff4] = ent4plot(X(1:sx(1),1:sx(2)),qstep, ...
 ['Haar Transform, Level 4 energies, and entropies for ' qstr], ...
 [-120 120 0 0.5], run);
if printon==1,
  print -depsc \1ngk\tex\i8coding\i8de3h5.eps
end

figure(11);
draw(max(min(X(1:sx(1),1:sx(2)),1600),-1600));
set(gcf,'numbertitle','off','name',['Level 4 Haar Transform'])
drawnow
if printon==5,
  drawfile(max(min(X(1:sx(1),1:sx(2)),1600),-1600),'\1ngk\tex\i8coding\i8de3p5.gif');
elseif printon==1,
  print -deps \1ngk\tex\i8coding\i8de3p5.eps
else
  pause
end

% Save transformed image X.
save haarx X sx

X = qstep*round(X/qstep);

% Draw a bar plot showing the entropy components from each subimage
% as a function of number of levels.
ee=zeros(13,5);
ee(1,1) = e0;
ee(4:-1:1,2:5) = e1 * (ones(1,4)/4);
ee(7:-1:4,3:5) = e2 * (ones(1,3)/16);
ee(10:-1:7,4:5) = e3 * (ones(1,2)/64);
ee(13:-1:10,5) = e4 / 256;
if printon==1
   save enthaar ee
end

% ee = cumsum(ee);
setfig(12)
subplot(1,1,1);
bar([0:4]',ee.','stacked');
xlabel('No. of Haar transform levels','FontSize',16);
title(['Cumulative Entropies of Subimages for ' qstr],'FontSize',16);
if qstep < 31,
  eec = cumsum(ee(1:4,2));
  text(1,mean(eec(3:4)),'Lo-Lo','horiz','center','vert','middle');
  text(1,mean(eec(2:3)),'Hi-Lo','horiz','center','vert','middle');
  text(1,mean(eec(1:2)),'Lo-Hi','horiz','center','vert','middle');
  text(1,mean([0;eec(1)]),'Hi-Hi','horiz','center','vert','middle');
end
set(gcf,'numbertitle','off','name',['Cumulative Entropies'])
drawnow
disp(['Entropies of Subimages for ' qstr]); ee

if printon==1,
  print -depsc \1ngk\tex\i8coding\i8de3h6.eps
end
if printon==2,
  print -depsc \1ngk\tex\i8coding\i8de3h8.eps
end

% Draw a bar plot showing the Huffman entropy components from each subimage
% as a function of number of levels.
eh=zeros(13,5);
eh(1,1) = ehuff0;
eh(4:-1:1,2:5) = ehuff1 * (ones(1,4)/4);
eh(7:-1:4,3:5) = ehuff2 * (ones(1,3)/16);
eh(10:-1:7,4:5) = ehuff3 * (ones(1,2)/64);
eh(13:-1:10,5) = ehuff4 / 256;
% eh = cumsum(eh);
setfig(13)
bar([0:4]',eh.','stacked');
xlabel('No. of Haar transform levels','FontSize',16);
title(['Cumulative Huffman Entropies of Subimages for ' qstr],'FontSize',16);
set(gcf,'numbertitle','off','name',['Huffman Entropies'])
if qstep < 31,
  eec = cumsum(eh(1:4,2));
  text(1,mean(eec(3:4)),'Lo-Lo','horiz','center','vert','middle');
  text(1,mean(eec(2:3)),'Hi-Lo','horiz','center','vert','middle');
  text(1,mean(eec(1:2)),'Lo-Hi','horiz','center','vert','middle');
  text(1,mean([0;eec(1)]),'Hi-Hi','horiz','center','vert','middle');
end
drawnow
disp(['Huffman Entropies of Subimages for ' qstr]); eh

if printon==1,
  print -depsc \1ngk\tex\i8coding\i8de3h7.eps
end
if printon==2,
  print -depsc \1ngk\tex\i8coding\i8de3h9.eps
end

figure(14);
draw(max(min(X,200),-200));
set(gcf,'numbertitle','off','name',['4 Levels - Haar Transform'])
save fig27d X
if printon==5,
  drawfile(max(min(X,200),-200),'\1ngk\tex\i8coding\i8de3p6.gif');
elseif printon==1,
  print -deps \1ngk\tex\i8coding\i8de3p6.eps
else
  pause
end

% Compute the inverse transform of the image X quantised with Qstep.
X(1:sx(1),1:sx(2)) = ihaar2d(X(1:sx(1),1:sx(2)));
sx = sx*2;
X(1:sx(1),1:sx(2)) = ihaar2d(X(1:sx(1),1:sx(2)));
sx = sx*2;
X(1:sx(1),1:sx(2)) = ihaar2d(X(1:sx(1),1:sx(2)));
sx = sx*2;
X = ihaar2d(X);
figure(15)
draw(X);
set(gcf,'numbertitle','off','name',['Inv. Transform - ' qstr])
drawnow
if printon==5,
  drawfile(X,'\1ngk\tex\i8coding\i8de3p7.gif');
elseif printon==1,
  print -deps \1ngk\tex\i8coding\i8de3p7.eps
end
if printon==6,
  drawfile(X,'\1ngk\tex\i8coding\i8de3p9.gif');
elseif printon==2,
  print -deps \1ngk\tex\i8coding\i8de3p9.eps
end

Y = X;

load lenna
X = X - 120;
haarrms = rms(rms(Y - X))

pelrms = rms(rms(qstep*round(X/qstep) - X))

figure(16)
draw(round(X/qstep));
set(gcf,'numbertitle','off','name',['Quantised pels - ' qstr])
drawnow
if printon==5,
  drawfile(round(X/qstep),'\1ngk\tex\i8coding\i8de3p8.gif');
elseif printon==1,
  print -deps \1ngk\tex\i8coding\i8de3p8.eps
end
if printon==6,
  drawfile(round(X/qstep),'\1ngk\tex\i8coding\i8de3p10.gif');
elseif printon==2,
  print -deps \1ngk\tex\i8coding\i8de3p10.eps
end

return;
