% DEMODCT.M
% Demonstrate the 4 and 8-point DCTs.

global printon
% printon = input('Write print files (0=no, 1=yes):');
printon = 0;

ns = 256;
theta = [0:ns] * pi / ns;
one = ones(1,ns+1);

offset = -[1:8];
scale = 1 / sqrt(8);
cs = [one; sqrt(2)*cos([1:7]'*theta)]*scale;

setfig(1)

subplot(1,2,1)
plot(theta*8/pi,cs(1:4,:)+offset(1:4)'*one,'-r');
hold on
plot([0;8],[1;1]*offset(1:4),':k')
x = [1:8] - 0.5;
plot(x,cs(1:4,x*ns/8+1)+offset(1:4)'*ones(1,8),'*b');
hold off
title('8-point DCT: rows 1 to 4','FontSize',16)
axis([0 8 -5 0]);

subplot(1,2,2)
plot(theta*8/pi,cs(5:8,:)+offset(5:8)'*one,'-r');
hold on
plot([0;8],[1;1]*offset(5:8),':k')
x = [1:8] - 0.5;
plot(x,cs(5:8,x*ns/8+1)+offset(5:8)'*ones(1,8),'*b');
hold off
title('8-point DCT: rows 5 to 8','FontSize',16)
axis([0 8 -9 -4]);

if printon==1,
  print -deps \1ngk\tex\i8coding\i8dct1.eps
end

mat2scr(cs(:,x*ns/8+1),'%8.4f&','8-point DCT matrix');
