% DEMODCT4.M
% Perform DCT analysis of Lenna using 16x16 DCTs and
% calculate entropies etc.

global printon
% printon = input('Write print files (0=no, 1=yes, 2=GIF):');
printon = 0;

% 1-D DCT matrix.
T = dctmat(16);

load lenna
X = X - 120;

disp('Doing DCT'); X=colxfm(colxfm(X,T)',T)'; 

X = regroup(X,16);

% DCT reordered into subimages grouped by coefficient type.
figure(1)
draw(X)
drawnow
if printon==2,
  drawfile(X,'\1ngk\tex\i8coding\i8dct41.gif');
elseif printon==1,
  print -deps \1ngk\tex\i8coding\i8dct41.eps
end

% Plot the 16 entropies of X using mesh and plot.
ent16 = dctent(X,15,16);
save ent16 ent16

mat2scr(ent16,'%8.4f','16 x 16 DCT entropy matrix');
mat2scr(mean(ent16(:)),'Mean entropy = %.4f bits');

if printon==0,
  pause
end

setfig(2);
subplot(1,2,1);
mesh(ent16');
view(110,20);
axis('square');
axis([0 17 0 17 0 8]);
grid on
title('Mesh plot of DCT entropy','FontSize',16);

subplot(1,2,2);
plot(ent16');
axis('square');
axis([0 16 0 8]);
grid on
title('Row plots of DCT entropy','FontSize',16);
xlabel('column','FontSize',16);
ylabel('Entropy (bit/pel)','FontSize',16);
text(1,ent16(1,1),'row 1','horiz','center','vert','bot');
text(1,ent16(2,1),'2 ','horiz','right','vert','mid');
text(1,ent16(3,1),'3 ','horiz','right','vert','mid');
text(1,ent16(16,1),'16','horiz','right','vert','mid');
if printon==1,
  print -deps \1ngk\tex\i8coding\i8dct42.eps
end

