% DEMODCT5_JPXR.M
% Compare DCT entropies with Haar entropies and include 2-level 4x4 DCT (JPXR).

global printon
printon = input('Write print files (0=no, 1=yes):');
% printon = 0;

load enthaar
load ent4
load ent8
load ent16
load ent44nofilt
ent44nofilt = ent44;
load ent44

% Assemble the entropies for the level 1, 2, 3 and 4 Haar transforms.
e(1:2:7) = sum(ee(:,2:5));

% Assemble the entropies for the 2, 4, 8 and 16 point DCTs.
e(2) = e(1);
e(4) = mean(mean(ent4));
e(6) = mean(mean(ent8));
e(8) = mean(mean(ent16));
e(9) = mean(mean(ent44nofilt));
e(10) = mean(mean(ent44));

disp('Haar and DCT entropies:')
% reshape(e,2,4)

% Plot the 8 entropies on a bar plot.
setfig(1)
subplot(1,1,1);
bar([1:length(e)]',e,'y');
axis([0 11 0 2.5]);
title('Mean Entropies for Haar Transforms and DCTs','FontSize',16);
if printon==1,
    set(gcf,'DefaultTextFontSize',14);
end
ylabel('Entropy (bit/pel)','FontSize',16);
st = 0.5;
text(1,st,'Level 1 Haar','Rot',90);
text(3,st,'Level 2 Haar','Rot',90);
text(5,st,'Level 3 Haar','Rot',90);
text(7,st,'Level 4 Haar','Rot',90);
text(2,st,'2x2 DCT','Rot',90);
text(4,st,'4x4 DCT','Rot',90);
text(6,st,'8x8 DCT','Rot',90);
text(8,st,'16x16 DCT','Rot',90);
text(9,0.4*st,'2-level 4x4 DCT, no filt','Rot',90);
text(10,0.4*st,'2-level 4x4 DCT + filt','Rot',90);
if printon==1,
    set(gcf,'DefaultTextFontSize',12);
end
for i=1:length(e),
  text(i,e(i),sprintf('%.4f',e(i)),'horiz','center','vert','bot');
end
% text(6,1.8,'JPEG','horiz','center','vert','bot');
% text(9.5,1.8,'JPXR','horiz','center','vert','bot');
drawnow

if printon==1,
  print -deps i8dct51b.eps
end

