% DEMODCT7.M
% Perform DCT analysis of Lenna using 8x8 DCTs with adjustable quantiser
% scale factors, and calculate entropies etc.

clear all
global printon
% printon = input('Write print files (0=no, 1=yes):');
printon = 0;

qscale = input('JPEG Q-table scale factor:');

% JPEG quantisation table for luminance.
qlum = jpegqtab;

qstep = qlum;

% 1-D DCT matrix.
T = dctmat(8);
xfmstr = '8x8 DCT';

load lenna
X = X - 120;

disp('Doing DCT'); X=colxfm(colxfm(X,T)',T)'; 
X = regroup(X,8);

% save lendct X

% Quantise using qstep=15.
qstep = qscale*jpegqtab;

[X,ent8a,rmsea] = dctquant(X,qstep,8);
ent8m = mean(mean(ent8a))
rmse = rms(rmsea(:))

% Perform inverse transform.
X = regroup(X,32);
disp('Doing Inv-DCT'); X = colxfm(colxfm(X',T')',T');
X = round(min(max(X + 120,1),255));

% Uncomment the following line only if you want to overwrite entdct8
% which is used by demwav2a (to compare DCT and wavelet methods).
% save entdct8 ent8a ent8m rmse X qstep T xfmstr

figure(1)
draw(X,[],[260 210])
drawnow
if printon==1,
  print -deps \1ngk\tex\i8coding\i8dct71.eps
end

return;