function y=drawrgb(a,posn);
% function y=drawrgb(a,map,posn);
% Function to display an image in a box matched to the pixel size.
% a  is assumed to be a 3-D true rgb matrix of uint8 values.
% If posn is specified, it determines the x and y position of the
% bottom left corner of the figure.


sz=get(0,'screensize');

xsize=sz(3);
ysize=sz(4);

sa=size(a);
m=sa(1); n=sa(2);

% scale=round(min([xsize/(2*n),(ysize)/(15*m/8)]));
scale=round(min([512/n,512/m]));  % Better for 2^n image sizes.

figure(gcf);

if scale==0

clf reset
image(a);
set(gca,'position',[0.01 0.01 .98 .98]);
axis('off');
axis('image');
set(gcf,'position',get(0,'screensize'));

else

clf reset

image(a);
axis('off');
axis('image')

if nargin < 2,
  fig = gcf;
  pos=[xsize-scale*n+12-fig.Number*20 fig.Number*20+14 scale*n+4 scale*m+4];
else
  pos=[posn(1)  posn(2)  scale*n+4  scale*m+4];
end
set(gcf,'position',pos);

u=get(gca,'units');
pos=[2 2 scale*n scale*m];
set(gca,'units','pixels');
set(gca,'position',pos);
set(gca,'units',u);

end



