function qstep = dwtqtab(q0,nlev,qinc)

% function qstep = dwtqtab(q0,nlev,qinc)
% Generate the DWT quantisation table for nlev levels of DWT.
% q0 is used at level nlev and for all Lo-Lo bands.
% qinc is the incrementing factor at each level.

qi = cumprod([q0; qinc*ones(nlev-1,1)]);
qstep = round([q0*ones(nlev,1)  qi(nlev:-1:1)*[1 1 qinc]]);

return;
