function y = haar2d(x)

% function y = haar2d(x)
% Perform a 2-D Haar transform on x.
% Use [1 1; 1 -1]/2 in order to preserve energy.
% The size of x must be even.

sx = size(x);
t1 = 1:2:sx(1);
t2 = 1:2:sx(2);

y = [x(:,t2)+x(:,t2+1)  x(:,t2)-x(:,t2+1)];
y = [y(t1,:)+y(t1+1,:); y(t1,:)-y(t1+1,:)] * 0.5;

return;
