function vlc = huffendc(rsa)

% function vlc = huffendc(rsa)
% Perform DC huffman encoding on the ampl coded 1st row
% of rsa, as produced by RUNAMPL.M.
% The codewords are variable length integers in vlc(:,1)
% whose lengths are in vlc(:,2).
% The global matrix ehufdc contains the huffman codes and their lengths.

global ehufdc huffhidc

% Code the size.
code = rsa(1,2) + 1;
huffhidc(code) = huffhidc(code) + 1;

% If size > 0, code the remainder.
if rsa(1,2) > 0,
  vlc = [ehufdc(code,:); rsa(1,[3 2])];
else
  vlc = ehufdc(code,:);
end

return 