% Image Coding Lectures:
% Fig 1.1: Sensitivity of the eye to luminance and chrominance intensity
% changes.

printon = input('Write print files (0=no, 1=yes):');

setfig(1)

log10f = [-100:200]'/100;
f = 10.^(log10f);
jf = f * sqrt(-1);

lum = abs((jf * 200) ./ (((1 + jf/5) .* (1 + jf/30)).^2));

rg = abs(140 ./ ((1 + jf/3).^4));

by = abs(80 ./ ((1 + jf/3.2).^4));

loglog(f,lum,'-w',f,rg,'-r',f,by,'-c');
axis([0.1 100 1 1000]);

text(5,500,'Luminance','horiz','center','vert','bottom');
text(1.1,110,'Red-Green Chrominance','horiz','left','vert','bot');
text(4,11,'Blue-Yellow Chrominance','horiz','right','vert','top');

xlabel('Spatial frequency (cycles/degree)')
ylabel('No. of perceivable levels')
title('Contrast Sensitivity of the Eye')

if printon==1,
  print -deps \1ngk\tex\i8coding\i8f1p1.eps
end
