function plotsep(h,sep)

% function plotsep(h,sep)
% Plot a set of impulse responses h using stair plots.
% The x-origin is at the mid point of h.
% Sep controls the vertical separation between the plot of each
% column of h.

if nargin < 2, sep = 0; end

[m,n]=size(h);
t = [1:m]' - (m+1)/2;

sepm = sep * ones(m,1) * [0:(n-1)];


% Add horizontal grid lines for each plot.
plot([t(1)-1;t(m)+1], -sep * [1;1] * [0:(n-1)], ':k')
hold on
stairs2(t-0.5, h - sepm);
hold off
axis([(m+1)/2*[-1 1]  sep*[0.5-n 1]]);

return

