function h = wav4(h0,h1)

% function h = wav4(h0,h1)
% Generate the 5 impulse responses of a 4-level wavelet tree
% in the columns of h(:,1:5).

h01 = conv(h0,upm(h1));
h00 = conv(h0,upm(h0));

h001 = conv(h0,upm(h01));
h000 = conv(h0,upm(h00));

h0001 = conv(h0,upm(h001));
h0000 = conv(h0,upm(h000));

nh = max(length(h0000),length(h0001)) + 2;

h = [extend(h1,nh) extend(h01,nh) extend(h001,nh) extend(h0001,nh) extend(h0000,nh)];

return;
